4ff3c75c78da706bd4e3074e987f571585502d1f
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 umask 002
6
7 sub=
8 mkdir -p $HOME$sub
9
10 : ${REPO=http://guvnor.distorted.org.uk/ftp/pub/mdw/profile}
11
12 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
13
14 ### Sort out command line
15 xstuff= false=
16 while [ $# -gt 0 ]; do
17 case "$1" in
18 -x) xstuff=t;;
19 -n) false=false;;
20 --) shift; break;;
21 -*) echo >&2 "$0: bad option"; exit 1;;
22 *) break;;
23 esac
24 shift
25 done
26
27 ### Find out where I am
28 here=$(pwd)
29
30 ### Suss out how to print things
31 out=$(echo -n "foo"; echo "bar")
32 if [ "$out" = "foobar" ]; then
33 echon="echo -n"
34 echoc=""
35 else
36 echon="echo"
37 echoc='\c'
38 fi
39
40 ### Create the necessary directories
41 echo "Creating directories..."
42 for i in bin lib/emacs src; do
43 $echon " $i:$echoc"
44 if [ -d $HOME$sub/$i ]; then
45 echo " already exists."
46 else
47 mkdir -p $HOME$sub/$i
48 echo " done."
49 fi
50 done
51 echo " all done."
52
53 ### Find out how to fetch things over the net
54 $echon "Finding URL fetcher:$echoc"
55 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
56 GETURL="curl -fs -o"
57 echo " curl."
58 elif wget >/dev/null 2>&1 --version; then
59 GETURL="wget -q -O"
60 echo " wget."
61 else
62 echo " failed!"
63 echo >&2 "$0: failed to find URL fetcher"
64 exit 1
65 fi
66
67 ### Install necessary things
68 echo "Installing useful scripts..."
69
70 scripts="
71 lesspipe.sh start-ssh-agent svnwrap"
72 [ "$xstuff" ] && scripts="$scripts
73 xrun"
74 for script in $scripts; do
75 $echon " $script:$echoc"
76 found=
77 for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
78 if $false [ -x $p/$script ]; then
79 found=t
80 break
81 fi
82 done
83 if [ "$found" ]; then
84 echo " already installed."
85 else
86 $echon " downloading$echoc"
87 $GETURL $HOME$sub/bin/$script $REPO/$script
88 chmod +x $HOME$sub/bin/$script
89 echo " done."
90 fi
91 done
92
93 echo " all done."
94
95 ### Install some more complicated programs
96 echo "Installing packages..."
97 systems="
98 mLib:2.0.3:mLib-config
99 chkpath:1.1.0:tmpdir
100 "
101 [ "$xstuff" ] && systems="$systems
102 mgLib:1.1.0:mgLib-config
103 xtoys:1.3.0:xscsize
104 "
105 for system in $systems; do
106 set -- $(echo $system | tr : ' ')
107 sys=$1 ver=$2 prog=$3
108 $echon " $sys:$echoc"
109 if $false $prog >/dev/null 2>&1 --version; then
110 echo " already installed."
111 else
112 ( set -e
113 $echon " downloading$echoc"
114 cd $HOME$sub/src
115 rm -rf $sys-$ver.tar.gz $sys-$ver
116 $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
117 $echon " unpacking$echoc"
118 gzip -cd $sys-$ver.tar.gz | tar xf -
119 $echon " configuring$echoc"
120 cd $sys-$ver
121 mkdir build
122 cd build
123 ../configure --prefix=$HOME$sub >>buildlog 2>&1
124 $echon " building$echoc"
125 make >>buildlog 2>&1
126 $echon " installing$echoc"
127 make install >>buildlog 2>&1
128 echo " done."
129 )
130 fi
131 done
132 echo " all done."
133
134 ### Install global configuration
135 echo -n "Installing dotfile configuration:"
136 if [ -f $HOME$sub/.mdw.conf ]; then
137 echo " already installed."
138 else
139 cp mdw.conf $HOME$sub/.mdw.conf
140 echo " done."
141 fi
142
143 ### Symlink the various dotfiles into place
144 dotfiles="
145 bash_profile bash_logout bashrc inputrc
146 emacs emacs-calc
147 vm mailrc signature
148 lisp-init.lisp:.cmucl-init.lisp
149 lisp-init.lisp:.sbclrc
150 lisp-init.lisp:.clisprc.lisp
151 dircolors screenrc cvsrc"
152 [ "$xstuff" ] && dotfiles="$dotfiles
153 xinitrc xsession Xdefaults vncrc vncsession
154 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
155 e-keybindings.cfg:.enlightenment/keybindings.cfg
156 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
157 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg"
158 mkdir -p $HOME/test
159 echo "Installing dotfiles..."
160 for d in $dotfiles; do
161 target=.$d
162 case $d in
163 *:*) target=${d#*:} d=${d%%:*};;
164 esac
165 ft=$HOME$sub/$target
166 dir=${ft%/*}
167 mkdir -p $dir
168 ln -s $here/$d $ft.new
169 mv $ft.new $ft
170 echo " $target"
171 done
172 echo " all done."
173
174 ### Set up the Emacs config
175 $echon "Finding a suitable emacs:$echoc"
176 emacs=no
177 for i in emacs21 emacs; do
178 if type -p >/dev/null $i; then
179 emacs=$i
180 break
181 fi
182 done
183 if [ $emacs = no ]; then
184 echo " failed."
185 emacs=:
186 else
187 echo " $emacs."
188 fi
189
190 echo "Installing Emacs packages..."
191 emacspkg="
192 make-regexp
193 git vc-git
194 quilt"
195 for elib in $emacspkg; do
196 $echon " $elib:$echoc"
197 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
198 (progn
199 (setq load-path (nconc load-path (list "~/lib/emacs")))
200 (kill-emacs (condition-case nil
201 (progn (load-library "'"$elib"'") 0)
202 (error 1))))'; then
203 echo " already installed."
204 else
205 $echon " downloading$echoc"
206 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
207 $echon " compiling$echoc"
208 (cd $HOME$sub/lib/emacs;
209 $emacs >/dev/null 2>&1 --no-site-file --batch \
210 --eval '(byte-compile-file "'"$elib.el"'")')
211 echo " done."
212 fi
213 done
214 echo " all done."
215
216 $echon "Setting up Emacs configuration:$echoc"
217 $echon " linking$echoc"
218 for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
219 set -- $(echo $link | tr : ' ')
220 from=$1 to=$2
221 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
222 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
223 done
224 $echon " compiling$echoc"
225 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
226 echo " done."